diff --git a/test/unit/commands/doctor_test.rb b/test/unit/commands/doctor_test.rb
index 946169f2..766bb1aa 100644
--- a/test/unit/commands/doctor_test.rb
+++ b/test/unit/commands/doctor_test.rb
@@ -853,4 +853,133 @@ class HiveCommandsDoctorTest < Minitest::Test
       refute doctor.send(:legacy_brainstorm_runtime_present?)
     end
   end
+
+  def test_required_checks_returns_structured_health_without_rendering
+    with_fake_home do |home|
+      install_brainstorm_and_plan_skills(home)
+      output = StringIO.new
+      doctor = Hive::Commands::Doctor.new(
+        config: base_config(
+          "brainstorm" => { "agent" => "claude", "skill" => "/x" },
+          "plan" => { "agent" => "claude", "skill" => "/x" }
+        ),
+        project_root: nil,
+        output: output,
+        agent_health_checker: lambda { |profile|
+          [ "present", "#{profile.name} healthy" ]
+        }
+      )
+
+      result = doctor.required_checks
+
+      assert result[:healthy]
+      assert_equal [ "claude" ],
+                   result[:rows].select { |row| row[:kind] == "agent" }.map { |row| row[:agent] }
+      assert_equal %w[brainstorm plan],
+                   result[:rows].select { |row| row[:kind] == "stage" }.map { |row| row[:stage] }
+      assert_empty output.string
+    end
+  end
+
+  def test_required_checks_rejects_agent_below_configured_minimum
+    with_fake_home do |home|
+      install_brainstorm_and_plan_skills(home)
+      claude = File.join(home, "bin", "claude")
+      write_file(claude, "#!/bin/sh\necho 'Claude 2.1.0'\n")
+      File.chmod(0o755, claude)
+      cfg = base_config(
+        "brainstorm" => { "agent" => "claude", "skill" => "/x" },
+        "plan" => { "agent" => "claude", "skill" => "/x" },
+        "agents" => {
+          "claude" => {
+            "bin" => claude,
+            "env_override" => "HIVE_CLAUDE_BIN",
+            "min_version" => "9.0.0"
+          }
+        }
+      )
+
+      result = Hive::Commands::Doctor.new(
+        config: cfg, project_root: nil
+      ).required_checks
+
+      refute result[:healthy]
+      agent = result[:rows].find { |row| row[:kind] == "agent" }
+      assert_equal "version_too_old", agent[:status]
+      assert_match(/below minimum 9\.0\.0/, agent[:message])
+    ensure
+      Hive::AgentProfile.reset_version_cache!
+    end
+  end
+
+  def test_required_checks_rejects_missing_agent_binary
+    with_fake_home do |home|
+      install_brainstorm_and_plan_skills(home)
+      missing = File.join(home, "bin", "missing-claude")
+      cfg = base_config(
+        "brainstorm" => { "agent" => "claude", "skill" => "/x" },
+        "plan" => { "agent" => "claude", "skill" => "/x" },
+        "agents" => {
+          "claude" => {
+            "bin" => missing,
+            "env_override" => "HIVE_CLAUDE_BIN",
+            "min_version" => "2.1.118"
+          }
+        }
+      )
+
+      result = Hive::Commands::Doctor.new(
+        config: cfg, project_root: nil
+      ).required_checks
+
+      refute result[:healthy]
+      agent = result[:rows].find { |row| row[:kind] == "agent" }
+      assert_equal "missing", agent[:status]
+      assert_match(/binary not runnable/, agent[:message])
+    ensure
+      Hive::AgentProfile.reset_version_cache!
+    end
+  end
+
+  def test_required_checks_runs_agent_preflight
+    with_fake_home do |home|
+      write_file("#{home}/.pi/agent/skills/ce-brainstorm/SKILL.md")
+      write_file("#{home}/.pi/agent/skills/wiki-plan/SKILL.md")
+      pi = File.join(home, "bin", "pi")
+      write_file(pi, "#!/bin/sh\necho 'pi 0.70.2'\n")
+      File.chmod(0o755, pi)
+      pi_roles = Hive::Config::ROLE_AGENT_PATHS.each_with_object({}) do |path, config|
+        cursor = config
+        path.each_with_index do |part, index|
+          cursor[part] ||= index == path.length - 1 ? "pi" : {}
+          cursor = cursor[part] unless index == path.length - 1
+        end
+      end
+      cfg = base_config(pi_roles).merge(
+        "agents" => {
+          "pi" => {
+            "bin" => pi,
+            "env_override" => "HIVE_PI_BIN",
+            "min_version" => "0.70.2"
+          }
+        },
+        "review" => pi_roles.fetch("review").merge(
+          "ci" => pi_roles.dig("review", "ci").merge("command" => nil),
+          "browser_test" => pi_roles.dig("review", "browser_test").merge("enabled" => false)
+        )
+      )
+
+      result = Hive::Commands::Doctor.new(
+        config: cfg, project_root: nil
+      ).required_checks
+
+      refute result[:healthy]
+      agent = result[:rows].find { |row| row[:kind] == "agent" }
+      assert_equal "pi", agent[:agent]
+      assert_equal "missing", agent[:status]
+      assert_match(/no provider configured|not found/, agent[:message])
+    ensure
+      Hive::AgentProfile.reset_version_cache!
+    end
+  end
 end
diff --git a/test/unit/config_test.rb b/test/unit/config_test.rb
index f9b9a92d..7c15a62f 100644
--- a/test/unit/config_test.rb
+++ b/test/unit/config_test.rb
@@ -2784,6 +2784,7 @@ class ConfigTest < Minitest::Test
       assert_equal 50,    cfg.dig("daemon", "max_runs_per_day_per_project")
       assert_equal 60,    cfg.dig("daemon", "transient_retry_backoff_sec")
       assert_equal 600,   cfg.dig("daemon", "shutdown_grace_sec")
+      assert_equal true,  cfg.dig("daemon", "auto_retry", "enabled")
       # R-02 per-child timeout knobs.
       assert_equal 0,     cfg.dig("daemon", "child_timeout_sec")
       assert_equal 30,    cfg.dig("daemon", "child_kill_grace_sec")
@@ -2896,6 +2897,34 @@ class ConfigTest < Minitest::Test
     end
   end
 
+  def test_load_honors_and_validates_daemon_auto_retry_kill_switch
+    with_tmp_dir do |dir|
+      FileUtils.mkdir_p(File.join(dir, ".hive-state"))
+      path = File.join(dir, ".hive-state", "config.yml")
+      File.write(path, <<~YAML)
+        daemon:
+          auto_retry:
+            enabled: false
+      YAML
+      assert_equal false, Hive::Config.load(dir).dig("daemon", "auto_retry", "enabled")
+
+      File.write(path, <<~YAML)
+        daemon:
+          auto_retry:
+            enabled: "no"
+      YAML
+      error = assert_raises(Hive::ConfigError) { Hive::Config.load(dir) }
+      assert_match(/daemon\.auto_retry\.enabled.*must be a boolean/, error.message)
+
+      File.write(path, <<~YAML)
+        daemon:
+          auto_retry: enabled
+      YAML
+      error = assert_raises(Hive::ConfigError) { Hive::Config.load(dir) }
+      assert_match(/daemon\.auto_retry.*must be a Hash/, error.message)
+    end
+  end
+
   def test_load_rejects_too_small_daemon_poll_interval
     with_tmp_dir do |dir|
       FileUtils.mkdir_p(File.join(dir, ".hive-state"))
@@ -3020,12 +3049,15 @@ class ConfigTest < Minitest::Test
           fast_poll_sec: 2
           max_concurrent_runs: 8
           log_max_bytes: 524288
+          auto_retry:
+            enabled: false
       YAML
       cfg = Hive::Config.load_global_daemon
       assert_equal 60,     cfg["poll_interval_sec"]
       assert_equal 2,      cfg["fast_poll_sec"]
       assert_equal 8,      cfg["max_concurrent_runs"]
       assert_equal 524_288, cfg["log_max_bytes"]
+      assert_equal false, cfg.dig("auto_retry", "enabled")
       # Unspecified keys still pull from defaults
       assert_equal 50, cfg["max_runs_per_day_per_project"]
       assert_equal 3,  cfg["max_concurrent_per_project"]
diff --git a/test/unit/daemon/auto_retry_history_test.rb b/test/unit/daemon/auto_retry_history_test.rb
new file mode 100644
index 00000000..37167830
--- /dev/null
+++ b/test/unit/daemon/auto_retry_history_test.rb
@@ -0,0 +1,130 @@
+require "test_helper"
+require "hive/daemon/auto_retry_history"
+
+class AutoRetryHistoryTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_reservations_survive_reconstruction_and_exhaust_after_two
+    with_tmp_dir do |dir|
+      history = Hive::Daemon::AutoRetryHistory.new
+      now = Time.utc(2026, 7, 24, 12)
+      assert history.reserve!(**reservation_args(dir, attempt: 1, fingerprint: "health-a", now: now))
+      assert history.reserve!(**reservation_args(dir, attempt: 2, fingerprint: "health-b", now: now + 1800))
+
+      decision = Hive::Daemon::AutoRetryHistory.new.assess(
+        task_folder: dir, reason: "implementer_failed",
+        fingerprint: "health-c", now: now + 3600
+      )
+      refute decision.eligible
+      assert_equal "retry_exhausted", decision.action
+    end
+  end
+
+  def test_second_attempt_requires_changed_fingerprint_and_backoff
+    with_tmp_dir do |dir|
+      history = Hive::Daemon::AutoRetryHistory.new
+      now = Time.utc(2026, 7, 24, 12)
+      history.reserve!(**reservation_args(dir, attempt: 1, fingerprint: "same", now: now))
+
+      unchanged = history.assess(task_folder: dir, reason: "implementer_failed",
+                                 fingerprint: "same", now: now + 3600)
+      assert_equal "health_unchanged", unchanged.action
+
+      early = history.assess(task_folder: dir, reason: "implementer_failed",
+                             fingerprint: "changed", now: now + 1799)
+      assert_equal "retry_backoff", early.action
+
+      ready = history.assess(task_folder: dir, reason: "implementer_failed",
+                             fingerprint: "changed", now: now + 1800)
+      assert ready.eligible
+      assert_equal 2, ready.attempt
+
+      assert_equal "retry_probe_due",
+                   history.budget(task_folder: dir, reason: "implementer_failed", now: now + 1800).action
+    end
+  end
+
+  def test_manual_clear_resets_only_matching_reason
+    with_tmp_dir do |dir|
+      history = Hive::Daemon::AutoRetryHistory.new
+      now = Time.utc(2026, 7, 24, 12)
+      history.reserve!(**reservation_args(dir, attempt: 1, fingerprint: "old", now: now))
+      Hive::Events.emit(
+        task_folder: dir, slug: "retry-task", stage: "4-execute",
+        event_type: :marker_cleared,
+        details: {
+          actor: "manual", marker_reason: "implementer_failed",
+          marker_id: "marker-1", timestamp: (now + 1).iso8601
+        }
+      )
+
+      decision = history.assess(task_folder: dir, reason: "implementer_failed",
+                                fingerprint: "old", now: now + 2)
+      assert decision.eligible
+      assert_equal 1, decision.attempt
+    end
+  end
+
+  def test_malformed_history_fails_closed
+    with_tmp_dir do |dir|
+      File.write(File.join(dir, "events.jsonl"), "{\"event_type\":")
+      decision = Hive::Daemon::AutoRetryHistory.new.assess(
+        task_folder: dir, reason: "implementer_failed", fingerprint: "x"
+      )
+      refute decision.eligible
+      assert_equal "history_invalid", decision.action
+    end
+  end
+
+  def test_invalid_reservation_timestamp_fails_closed_in_budget_and_assessment
+    with_tmp_dir do |dir|
+      details = {
+        "marker_reason" => "implementer_failed",
+        "attempt" => 1,
+        "health_fingerprint" => "health-a",
+        "timestamp" => "not-a-time"
+      }
+      File.write(
+        File.join(dir, "events.jsonl"),
+        "#{JSON.generate("event_type" => "auto_retry_reserved", "details" => details)}\n"
+      )
+      history = Hive::Daemon::AutoRetryHistory.new
+
+      assert_equal "history_invalid",
+                   history.budget(task_folder: dir, reason: "implementer_failed").action
+      assert_equal "history_invalid",
+                   history.assess(
+                     task_folder: dir, reason: "implementer_failed",
+                     fingerprint: "health-b"
+                   ).action
+    end
+  end
+
+  def test_reservation_rejects_non_json_probe_details
+    with_tmp_dir do |dir|
+      args = reservation_args(
+        dir, attempt: 1, fingerprint: "health-a", now: Time.now
+      )
+      args[:probes] = [ Float::NAN ]
+
+      refute Hive::Daemon::AutoRetryHistory.new.reserve!(**args)
+    end
+  end
+
+  private
+
+  def reservation_args(dir, attempt:, fingerprint:, now:)
+    {
+      task_folder: dir,
+      task_id: 42,
+      slug: "retry-task",
+      stage: "4-execute",
+      marker_id: "marker-#{attempt}",
+      reason: "implementer_failed",
+      fingerprint: fingerprint,
+      attempt: attempt,
+      probes: [],
+      now: now
+    }
+  end
+end
diff --git a/test/unit/daemon/auto_retry_policy_test.rb b/test/unit/daemon/auto_retry_policy_test.rb
new file mode 100644
index 00000000..4579705c
--- /dev/null
+++ b/test/unit/daemon/auto_retry_policy_test.rb
@@ -0,0 +1,352 @@
+require "test_helper"
+require "hive/daemon/auto_retry_policy"
+require "hive/daemon/status_consumer"
+
+class AutoRetryPolicyTest < Minitest::Test
+  include HiveTestHelper
+
+  FakeTask = Struct.new(
+    :log_dir, :worktree_yml_path, :folder, :project_root,
+    keyword_init: true
+  )
+
+  def test_codex_auth_requires_production_execute_marker_and_auth_log
+    with_policy_fixture(stage: "4-execute", reason: "implementer_failed") do |fixture|
+      auth = "request failed with 401: Missing bearer or basic authentication in header"
+      fixture.write_log(auth)
+      fixture.marker_attrs.merge!("status" => "error", "message" => "exit_code=1")
+      fixture.rewrite_marker
+
+      decision = fixture.policy.evaluate(fixture.row)
+      assert decision.eligible, decision.inspect
+      assert_equal "eligible", decision.action
+
+      non_codex_policy = Hive::Daemon::AutoRetryPolicy.new(
+        task_builder: ->(_folder) { fixture.task },
+        config_loader: ->(_root) { { "execute" => { "agent" => "claude" } } }
+      )
+      denied = non_codex_policy.evaluate(fixture.row)
+      refute denied.eligible
+      assert_equal "codex_agent_mismatch", denied.action
+
+      fixture.marker_attrs["message"] = auth
+      fixture.rewrite_marker
+      denied = fixture.policy.evaluate(fixture.row)
+      refute denied.eligible
+      assert_equal "codex_execute_marker_invalid", denied.action
+    end
+  end
+
+  def test_stale_codex_auth_in_older_log_does_not_classify
+    with_policy_fixture(stage: "4-execute", reason: "implementer_failed") do |fixture|
+      auth = "401 Missing bearer or basic authentication in header"
+      fixture.write_log(auth, suffix: "old")
+      fixture.write_log("business logic failed", suffix: "new", newer: true)
+      fixture.marker_attrs.merge!("status" => "error", "message" => "exit_code=1")
+      fixture.rewrite_marker
+
+      decision = fixture.policy.evaluate(fixture.row)
+      refute decision.eligible
+      assert_equal "codex_auth_signature_missing", decision.action
+    end
+  end
+
+  def test_codex_auth_requires_current_agent_and_exact_episode_log
+    with_policy_fixture(stage: "4-execute", reason: "implementer_failed") do |fixture|
+      fixture.write_log("401 Missing bearer or basic authentication in header", suffix: "old")
+      fixture.marker_attrs.merge!(
+        "status" => "error",
+        "message" => "exit_code=1",
+        "log_file" => "execute-impl-current.log"
+      )
+      fixture.rewrite_marker
+
+      missing = fixture.policy.evaluate(fixture.row)
+      refute missing.eligible
+      assert_equal "codex_log_missing", missing.action
+
+      fixture.marker_attrs["agent"] = "claude"
+      fixture.rewrite_marker
+      wrong_agent = fixture.policy.evaluate(fixture.row)
+      refute wrong_agent.eligible
+      assert_equal "codex_agent_mismatch", wrong_agent.action
+    end
+  end
+
+  def test_claude_marker_requires_writer_attribution
+    with_policy_fixture(stage: "2-brainstorm", reason: "claude_launch_failed") do |fixture|
+      fixture.attribute_claude!
+      assert fixture.policy.evaluate(fixture.row).eligible
+
+      fixture.marker_attrs.delete("writer")
+      fixture.rewrite_marker
+      decision = fixture.policy.evaluate(fixture.row)
+      refute decision.eligible
+      assert_equal "claude_marker_unattributed", decision.action
+    end
+  end
+
+  def test_answered_brainstorm_and_substantive_plan_are_unsafe
+    with_policy_fixture(stage: "2-brainstorm", reason: "claude_launch_failed") do |fixture|
+      fixture.attribute_claude!
+      File.write(fixture.state_file, "## Round 1\n### Q1. Choose?\n### A1.\nUser answer\n")
+      fixture.rewrite_marker(append: true)
+      assert_equal "brainstorm_answered", fixture.policy.evaluate(fixture.row).action
+    end
+
+    with_policy_fixture(stage: "3-plan", reason: "claude_launch_failed") do |fixture|
+      fixture.attribute_claude!
+      File.write(fixture.state_file, "# Plan\n\nBuild the retry subsystem.\n")
+      fixture.rewrite_marker(append: true)
+      assert_equal "plan_substantive", fixture.policy.evaluate(fixture.row).action
+    end
+
+    with_policy_fixture(stage: "3-plan", reason: "claude_launch_failed") do |fixture|
+      fixture.attribute_claude!
+      File.write(fixture.state_file, "---\nowner: user\n---\n# Plan\n")
+      fixture.rewrite_marker(append: true)
+      assert_equal "plan_substantive", fixture.policy.evaluate(fixture.row).action
+    end
+  end
+
+  def test_worktree_stages_require_a_completely_clean_git_worktree
+    with_policy_fixture(stage: "5-open-pr", reason: "claude_launch_failed") do |fixture|
+      fixture.attribute_claude!
+      assert fixture.policy.evaluate(fixture.row).eligible
+
+      File.write(File.join(fixture.worktree, "dirty.txt"), "user work")
+      decision = fixture.policy.evaluate(fixture.row)
+      refute decision.eligible
+      assert_equal "worktree_dirty", decision.action
+    end
+  end
+
+  def test_worktree_pointer_must_exist_be_contained_and_registered
+    with_policy_fixture(stage: "5-open-pr", reason: "claude_launch_failed") do |fixture|
+      fixture.attribute_claude!
+      File.unlink(fixture.task.worktree_yml_path)
+      assert_equal "worktree_pointer_missing", fixture.policy.evaluate(fixture.row).action
+
+      File.write(fixture.task.worktree_yml_path, { "path" => fixture.project_root }.to_yaml)
+      assert_equal "worktree_pointer_invalid", fixture.policy.evaluate(fixture.row).action
+
+      unregistered = File.join(File.dirname(fixture.worktree), "unregistered")
+      FileUtils.mkdir_p(unregistered)
+      run!("git", "-C", unregistered, "init", "-b", "main", "--quiet")
+      File.write(fixture.task.worktree_yml_path, { "path" => unregistered }.to_yaml)
+      assert_equal "worktree_unregistered", fixture.policy.evaluate(fixture.row).action
+    end
+  end
+
+  def test_worktree_git_checks_have_a_hard_deadline
+    with_policy_fixture(stage: "5-open-pr", reason: "claude_launch_failed") do |fixture|
+      fixture.attribute_claude!
+      timed_out = Hive::Daemon::BoundedCommand::Result.new(
+        stdout: "", stderr: "", status: nil, timed_out: true
+      )
+      policy = Hive::Daemon::AutoRetryPolicy.new(
+        task_builder: ->(_folder) { fixture.task },
+        command_runner: ->(**) { timed_out }
+      )
+      assert_equal "worktree_status_timeout", policy.evaluate(fixture.row).action
+    end
+  end
+
+  def test_marker_identity_change_and_unknown_reason_fail_closed
+    with_policy_fixture(stage: "4-execute", reason: "unknown_failure") do |fixture|
+      decision = fixture.policy.evaluate(fixture.row)
+      refute decision.eligible
+      assert_equal "reason_not_allowlisted", decision.action
+    end
+  end
+
+  def test_policy_errors_and_private_unknown_reason_fail_closed
+    with_policy_fixture(stage: "4-execute", reason: "implementer_failed") do |fixture|
+      policy = Hive::Daemon::AutoRetryPolicy.new(
+        task_builder: ->(_folder) { raise IOError, "task unreadable" }
+      )
+      assert_equal "policy_error", policy.evaluate(fixture.row).action
+
+      decision = fixture.policy.send(
+        :classify_reason, "future_reason", fixture.row,
+        FakeTask.new(log_dir: fixture.log_dir)
+      )
+      assert_equal "reason_not_allowlisted", decision.action
+    end
+  end
+
+  def test_codex_current_episode_and_readability_fail_closed
+    with_policy_fixture(stage: "4-execute", reason: "implementer_failed") do |fixture|
+      auth = "401 Missing bearer or basic authentication in header"
+      log = fixture.write_log(auth)
+      fixture.marker_attrs.merge!("status" => "error", "message" => "exit_code=1")
+      fixture.rewrite_marker
+      future = Time.now + 5
+      File.utime(future, future, log)
+      assert_equal "codex_log_episode_ambiguous",
+                   fixture.policy.evaluate(fixture.row).action
+
+      with_replaced_singleton_method(
+        Hive::DiagnosticHelpers, :tail_file,
+        ->(_path) { raise IOError, "unreadable" }
+      ) do
+        assert_equal "codex_log_unreadable",
+                     fixture.policy.evaluate(fixture.row).action
+      end
+    end
+  end
+
+  def test_claude_unsupported_stage_marker_change_and_prior_success_are_unsafe
+    with_policy_fixture(stage: "1-inbox", reason: "claude_launch_failed") do |fixture|
+      fixture.attribute_claude!
+      assert_equal "claude_stage_unsupported",
+                   fixture.policy.evaluate(fixture.row).action
+    end
+
+    with_policy_fixture(stage: "2-brainstorm", reason: "claude_launch_failed") do |fixture|
+      fixture.attribute_claude!
+      Hive::Markers.set(
+        fixture.state_file, :error,
+        fixture.marker_attrs.merge("marker_id" => "replacement")
+      )
+      assert_equal "marker_changed", fixture.policy.evaluate(fixture.row).action
+    end
+
+    with_policy_fixture(stage: "2-brainstorm", reason: "claude_launch_failed") do |fixture|
+      fixture.attribute_claude!
+      File.write(fixture.state_file, "<!-- COMPLETE -->\n")
+      fixture.rewrite_marker(append: true)
+      assert_equal "terminal_success_present",
+                   fixture.policy.evaluate(fixture.row).action
+    end
+  end
+
+  def test_plan_scaffolding_passes_and_unknown_or_unreadable_stage_safety_denies
+    with_policy_fixture(stage: "3-plan", reason: "claude_launch_failed") do |fixture|
+      fixture.attribute_claude!
+      File.write(fixture.state_file, "# Plan\n\n")
+      fixture.rewrite_marker(append: true)
+      assert fixture.policy.evaluate(fixture.row).eligible
+    end
+
+    with_policy_fixture(stage: "2-brainstorm", reason: "claude_launch_failed") do |fixture|
+      fixture.attribute_claude!
+      fixture.row.stage = "future-stage"
+      assert_equal "stage_safety_unknown",
+                   fixture.policy.send(:safe_to_retry, fixture.row, Object.new).action
+
+      with_replaced_singleton_method(
+        Hive::Markers, :current, ->(_path) { raise IOError, "unreadable" }
+      ) do
+        assert_equal "stage_state_unreadable",
+                     fixture.policy.send(:safe_to_retry, fixture.row, Object.new).action
+      end
+    end
+  end
+
+  def test_git_spawn_error_is_unsafe
+    with_policy_fixture(stage: "5-open-pr", reason: "claude_launch_failed") do |fixture|
+      fixture.attribute_claude!
+      policy = Hive::Daemon::AutoRetryPolicy.new(
+        task_builder: ->(_folder) { fixture.task },
+        command_runner: ->(**) { raise Errno::ENOENT, "git" }
+      )
+      assert_equal "worktree_status_failed", policy.evaluate(fixture.row).action
+    end
+  end
+
+  private
+
+  Fixture = Struct.new(
+    :dir, :project_root, :worktree, :task, :state_file, :log_dir,
+    :marker_attrs, :row, :policy,
+    keyword_init: true
+  ) do
+    def write_log(text, suffix: "current", newer: false)
+      path = File.join(log_dir, "execute-impl-#{suffix}.log")
+      File.write(path, text)
+      time = Time.now - (newer ? 1 : 2)
+      File.utime(time, time, path)
+      File.utime(Time.now, Time.now, state_file)
+      marker_attrs["agent"] = "codex"
+      marker_attrs["log_file"] = File.basename(path)
+      path
+    end
+
+    def rewrite_marker(append: false)
+      if append
+        File.open(state_file, "a") do |file|
+          file.puts Hive::Markers.build_marker("ERROR", marker_attrs)
+        end
+      else
+        Hive::Markers.set(state_file, :error, marker_attrs)
+      end
+      row.marker_attrs = marker_attrs
+    end
+
+    def attribute_claude!
+      marker_attrs.merge!(
+        "writer" => Hive::Daemon::AutoRetryPolicy::CLAUDE_MARKER_WRITER,
+        "exception_class" => "Hive::AgentError",
+        "message" => "launcher failed"
+      )
+      rewrite_marker
+    end
+  end
+
+  def with_policy_fixture(stage:, reason:, worktree: nil)
+    with_tmp_dir do |dir|
+      project_root = File.join(dir, "project")
+      worktree_root = File.join(dir, "worktrees")
+      FileUtils.mkdir_p(File.join(project_root, ".hive-state"))
+      File.write(
+        File.join(project_root, ".hive-state", "config.yml"),
+        {
+          "worktree_root" => worktree_root,
+          "execute" => { "agent" => "codex" }
+        }.to_yaml
+      )
+      run!("git", "-C", project_root, "init", "-b", "main", "--quiet")
+      run!("git", "-C", project_root, "config", "user.email", "test@example.com")
+      run!("git", "-C", project_root, "config", "user.name", "Test")
+      File.write(File.join(project_root, "README.md"), "fixture\n")
+      run!("git", "-C", project_root, "add", "README.md")
+      run!("git", "-C", project_root, "commit", "-m", "fixture", "--quiet")
+
+      folder = File.join(project_root, ".hive-state", "stages", stage, "retry-task")
+      FileUtils.mkdir_p(folder)
+      if Hive::Daemon::AutoRetryPolicy::WORKTREE_STAGES.include?(stage)
+        worktree ||= File.join(worktree_root, "retry-task")
+        run!("git", "-C", project_root, "worktree", "add", "--quiet",
+             "-b", "retry-task", worktree)
+        File.write(File.join(folder, "worktree.yml"), { "path" => worktree }.to_yaml)
+      end
+      state_file = File.join(folder, stage == "3-plan" ? "plan.md" : "task.md")
+      log_dir = File.join(project_root, ".hive-state", "logs", "retry-task")
+      FileUtils.mkdir_p(log_dir)
+      marker_attrs = {
+        "reason" => reason,
+        "marker_id" => "marker-current"
+      }
+      Hive::Markers.set(state_file, :error, marker_attrs)
+      row = Hive::Daemon::StatusConsumer::Row.new(
+        project: "project", slug: "retry-task", stage: stage,
+        marker: "error", marker_attrs: marker_attrs, folder: folder,
+        state_file: state_file, action: "error"
+      )
+      task = FakeTask.new(
+        log_dir: log_dir,
+        worktree_yml_path: File.join(folder, "worktree.yml"),
+        folder: folder,
+        project_root: project_root
+      )
+      policy = Hive::Daemon::AutoRetryPolicy.new(task_builder: ->(_folder) { task })
+      fixture = Fixture.new(
+        dir: folder, project_root: project_root, worktree: worktree, task: task,
+        state_file: state_file, log_dir: log_dir,
+        marker_attrs: marker_attrs, row: row, policy: policy
+      )
+      yield fixture
+    end
+  end
+end
